/*
	$Id: ItemAlreadyExistsException.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This exception is thrown when trying to save an object 
	and another object with the same ID already exists.

	@author Nicklas
	@version 2.0
*/
public class ItemAlreadyExistsException
	extends InvalidDataException
{
	
	/**
		
	*/
	private static final long serialVersionUID = 8355317881537705674L;

	/**
		Creates a new <code>ItemAlreadyExistsException</code>. The error
		message produced will look like:
		<code>Item already exists: User[Login=peter]

		@param what A description of what already exists, for 
			example User[Login=peter]
	*/
	public ItemAlreadyExistsException(String what)
	{
		super("Item already exists: "+what);
	}
	

}



