/*
	$Id$

	Copyright (C) 2005 Johan Enell
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This class connects the ArrayDesign with its plates and adding an index to that connection.
	
	@author enell
	@version 2.0
	@see net.sf.basedb.core.ArrayDesign
	@see net.sf.basedb.core.Plate
	@see <a href="../../../../../../html/developerdoc/api/data_api.arrays.html">Array LIMS - arrays overview</a>
	@base.modified $Date$
	@hibernate.class table="`ArrayDesignPlates`" lazy="false"
*/
public class ArrayDesignPlateData 
	extends BasicData
{
	private int position;
	/**
		Get the index. Must be unique within the array design.
		@hibernate.property column="`position`" type="int" not-null="true" update="false" unique-key="uniqueposition"
	*/
	public int getPosition()
	{
		return position;
	}
	public void setPosition(int position)
	{
		this.position = position;
	}
	
	private ArrayDesignData arrayDesign;
	/**
	   Get the ArrayDesign
	   @hibernate.many-to-one column="`arraydesign_id`" not-null="true" update="false" unique-key="uniqueposition"
	*/
	public ArrayDesignData getArrayDesign()
	{
	   return arrayDesign;
	}
	public void setArrayDesign(ArrayDesignData arrayDesign)
	{
	   this.arrayDesign = arrayDesign;
	}
	
	private PlateData plate;
	/**
		Get the Plate.
		@hibernate.many-to-one column="`plate_id`" not-null="true" update="false"
	*/
	public PlateData getPlate()
	{
		return plate;
	}
	public void setPlate(PlateData plate)
	{
		this.plate = plate;
	}
}
