/*
  $Id: HardwareTypeData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Set;

/**
	This class holds information about a hardwaretype.
	
	@author enell
 	@version 2.0
	@see net.sf.basedb.core.HardwareType
	@see <a href="../../../../../../html/developerdoc/api/data_api.wares.html">Hardware and software overview</a>
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
	@hibernate.class table="`HardwareTypes`" lazy="false"
*/
public class HardwareTypeData
	extends BasicData
	implements NameableData, SystemData, RemovableData
{
	/*
		From the NameableData interface
		-------------------------------------------
	*/
	private String name;
	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name  = name;
	}

	private String description;
	public String getDescription()
	{
		return description;
	}

	public void setDescription(String description)
	{
		this.description = description;
	}
	//  -------------------------------------------
	/*
		From the RemovableData interface
		-------------------------------------------
	*/
	private boolean removed;
	public boolean isRemoved()
	{
		return removed;
	}
	public void setRemoved(boolean removed)
	{
		this.removed = removed;
	}
	// -------------------------------------------
	/*
		From the SystemData interface
		-------------------------------------------
	*/
	private String systemId;
	public String getSystemId()
	{
		return systemId;
	}
	public void setSystemId(String systemId)
	{
		this.systemId = systemId;
	}
	// -------------------------------------------
	
	private Set<HardwareData> hardware;
	/**
		This is the inverse end.
		@hibernate.set lazy="true" inverse="true" cascade="delete"
		@hibernate.collection-key column="`hardwaretype_id`"
		@hibernate.collection-one-to-many class="net.sf.basedb.core.data.HardwareData"
	*/
	public Set<HardwareData> getHardware()
	{
		return hardware;
	}
	
	void setHardware(Set<HardwareData> hardware)
	{
		this.hardware = hardware;
	}

}
