/*
  $Id: UserClientSettingData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Johan Enell, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	@author nicklas
	@see net.sf.basedb.core.UserClientSetting
	@see <a href="../../../../../../html/developerdoc/api/data_api.clients.html">Session and client overview</a>
	@hibernate.class table="`UserClientSettings`" lazy="false"
	@version 2.0
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
 */
public class UserClientSettingData
	extends SettingData
{

	public UserClientSettingData()
	{}
	
	private UserData user;
	/**
		Get the user this setting is valid for.
		@hibernate.many-to-one update="false" outer-join="false"
		@hibernate.column name="`user_id`" not-null="true" unique-key="uniquesetting"
	*/
	public UserData getUser()
	{
		return user;
	}
	public void setUser(UserData user)
	{
		this.user = user;
	}
	
	private ClientData client;
	/**
		Get the client application this setting is valid for.
		@hibernate.many-to-one update="false" outer-join="false"
		@hibernate.column name="`client_id`" not-null="true" unique-key="uniquesetting"
	*/
	public ClientData getClient()
	{
		return client;
	}
	public void setClient(ClientData client)
	{
		this.client = client;
	}
}
