/*
	$Id: QueryResult.java 4516 2008-09-11 20:09:17Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.query;

/**
	This is the root interface for query results. This is not a required
	interface, but we recommend query implementations to use it.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-11 22:09:17 +0200 (Thu, 11 Sep 2008) $
*/
public interface QueryResult
{
	/**
		Get the total number of items returned by the query, ignoring
		any limits set by {@link Query#setFirstResult(int)} and
		{@link Query#setMaxResults(int)}. If the 
		{@link Query#setReturnTotalCount(boolean)} hasn't been enabled this method may
		not return a correct value.

		@return The total number of items, or -1 if not known
		@see Query#setReturnTotalCount(boolean)
	*/
	public long getTotalCount();
}
