/**
	$Id: Filter.java 4594 2008-10-21 07:20:40Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.filter;

/**
	A filter is something that selectes or rejects an object 
	due to some property of it. Filters are often used to 
	filter a collection of object to create a sub-collection
	where all objects share some property.

	@author Nicklas
	@version 2.9
	@see FilterUtil
	@base.modified $Date: 2008-10-21 09:20:40 +0200 (Tue, 21 Oct 2008) $
*/
public interface Filter<T>
{
	/**
		Evaluate if the given object should pass the filter or not.
		@param object The object to evaluate
		@return TRUE if the object passes the filter, FALSE otherwise
	*/
	public boolean evaluate(T object);

}
