<%-- $Id: view_project.jsp 4578 2008-10-13 14:38:58Z martin $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.PROJECT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Project project = Project.getById(dc, itemId);
	
	final boolean usePermission = project.hasPermission(Permission.USE);
	final boolean writePermission = project.hasPermission(Permission.WRITE);
	final boolean deletePermission = project.hasPermission(Permission.DELETE);
	final boolean setOwnerPermission = project.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = project.isRemoved();
	final boolean isUsed = isRemoved && project.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = project.isOwner();
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function setToActive()
		{
			Main.openPopup('set_active.jsp?ID=<%=ID%>&project_id=<%=itemId%>', 'ActivateProject', 300, 140);
		}
		function viewItems()
		{
			location.href = 'items/index.jsp?ID=<%=ID%>&project_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'items')
			{
				viewItems();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Projects" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(project.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this project" : "You do not have permission to edit this project"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!project.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this project" : "You do not have permission to delete this project"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=project.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this project" : "You do not have permission to restore this project"%>" 
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				onclick="setToActive()" 
				image="bullet.gif"
				title="Set active"
				tooltip="Set this project to the active project"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'project.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(project)%></i></div>
			<%
			if (project.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(project.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=project%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(project.getDescription())%></td>
			</tr>
			</table>
			
			<h4 class="docked">Members</h4>
			
			<tbl:table
				id="members"
				clazz="itemlist"
				columns="all"
				>
				<tbl:columndef
					id="type"
					title="User/Group"
				/>
				<tbl:columndef
					id="name"
					title="Name"
				/>
				<tbl:columndef
					id="permissions"
					title="Permissions"
				/>
				<tbl:data>
					<tbl:columns />
					<tbl:rows>
					<%
					// Query to retrieve child groups
					ItemQuery<Group> groupQuery = project.getGroups();
					groupQuery.include(Include.ALL);
					groupQuery.order(Orders.asc(Hql.property("name")));
					ItemResultList<Group> groups = groupQuery.list(dc);
					for (Group group : groups)
					{
						Set<Permission> permissions = project.getPermissions(group);
						%>
						<tbl:row>
							<tbl:cell column="type">Group</tbl:cell>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
							<tbl:cell column="permissions"><%=permissions.toString().replaceAll("\\[|\\]", "")%></tbl:cell>
						</tbl:row>
						<%
					}
			
					// Query to retrieve user members
					ItemQuery<User> userQuery = project.getUsers();
					userQuery.include(Include.ALL);
					userQuery.order(Orders.asc(Hql.property("name")));
					ItemResultList<User> users = userQuery.list(dc);
					for (User user : users)
					{
						Set<Permission> permissions = project.getPermissions(user);
						%>
						<tbl:row>
							<tbl:cell column="type">User</tbl:cell>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
							<tbl:cell column="permissions"><%=permissions.toString().replaceAll("\\[|\\]", "")%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
			</tbl:table>
			
			<h4 class="docked">Defaults</h4>			
			<tbl:table 
				id="defaults"
				clazz="itemlist"
				columns="all"
			>
			<tbl:columndef
				id="setting"
				title="Setting"
			/>
			<tbl:columndef
				id="value"
				title="Value"
			/>
			<tbl:data>
				<tbl:columns />
					<tbl:rows>			
					<%		
					// Check each Default if it has any value
					for (Project.Default d : Project.Default.values())
					{
						boolean readDefaultValue = true;
						String defaultName = d.getShortName();
						String value = null;
						if (d.getItemType() != null)
						{
							BasicItem item = null;
							try
							{
								item = project.getDefaultItem(dc, d);	
								if (item != null)
								{
									value = item instanceof Nameable ? Base.getLinkedName(ID, (Nameable)item, false, true) : item.toString();
								}
							}
							catch (PermissionDeniedException ex)
							{
								readDefaultValue = false;
								value = "<i>- denied -</i>";
							}							
						}
						else if (d.equals(Project.Default.RAW_DATA_TYPE))
						{
							RawDataType rdt = project.getDefaultRawDataType();
							value = rdt != null ? rdt.getName() : null;
						}
						if (value != null)
						{
							%>
							<tbl:row>
								<tbl:cell column="setting"><%=defaultName%></tbl:cell>
								<tbl:cell column="value"><%=value%></tbl:cell>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
			</tbl:table>			
		</div>
			</t:tab>
			
			<t:tab id="items" title="Items" tooltip="List all items in this project" />
			
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
