<%-- $Id: list_bioassaysets.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Transformation"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Tree"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.LinkedList"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.Iterator"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAYSET;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%!

private static void addToTree(Tree<BasicItem> tree, BioAssaySet bas)
{
	if (!tree.contains(bas))
	{
		Transformation transformation = bas.getTransformation();
		Tree.Entry<BasicItem> parent = tree.getEntry(transformation);
		if (parent == null) 
		{
			addToTree(tree, transformation);
			parent = tree.getEntry(transformation);
		}
		parent.addChild(bas);
	}
}

private static void addToTree(Tree<BasicItem> tree, Transformation transformation)
{
	if (!tree.contains(transformation))
	{
		BioAssaySet source = transformation.getSource();
		Tree.Entry<BasicItem> parent = tree.getEntry(source);
		if (parent == null) 
		{
			addToTree(tree, source);
			parent = tree.getEntry(source);
		}
		parent.addChild(transformation);
	}
}

private static Tree<BasicItem> getAnalysisTree(DbControl dc, ItemQuery<BioAssaySet> bioAssaySetQuery, ItemQuery<Transformation> transformationQuery)
{
	Tree<BasicItem> tree = new Tree<BasicItem>(null);
	ItemResultList<BioAssaySet> allBioAssaySets = bioAssaySetQuery.list(dc);
	List<Integer> ids = new ArrayList<Integer>(allBioAssaySets.size());
	
	for (BioAssaySet bas : allBioAssaySets)
	{
		addToTree(tree, bas);
		ids.add(bas.getId());
	}
	
	transformationQuery.restrict(
		Restrictions.in(
			Hql.property("source.id"), 
			Expressions.parameter("bioAssaySets", ids)
		)
	);
	ItemResultList<Transformation> allTransformations = transformationQuery.list(dc);
	for (Transformation t: allTransformations)
	{
		addToTree(tree, t);
	}
	return tree;
}
String generateTree(Tree<BasicItem> tree, BasicItem root, Collection<String> closed)
{
	StringBuilder sb = new StringBuilder();
	Tree.Entry<BasicItem> rootEntry = tree.getEntry(root);
	if (rootEntry == null) return "";
	
	List<Tree.Entry<BasicItem>> children = rootEntry.getChildren();
	if (children != null)
	{
		for (Tree.Entry<BasicItem> child : children)
		{
			BasicItem node = child.getNode();
			int id = node.getId();
			String var = node.getType().name() + "_" + id;
			String name = ((Nameable)node).getName();
			
			String folderIcon = node.getType() == Item.BIOASSAYSET ?
				"BioAssaySet" : "Transformation";
			sb.append("var ").append(var);
			if (root == null)
			{
				sb.append(" = JoustMenu.addMenuItem(-1");
			}
			else
			{
				String rootVar = root.getType().name() + "_" + root.getId();
				sb.append(" = JoustMenu.addChildItem(").append(rootVar); 
			}
			sb.append(",'").append(folderIcon).append("'");
			sb.append(",'").append(HTML.javaScriptEncode(name)).append("'");
			sb.append(", null, '', '").append(var).append("');\n");
			if ((closed == null || !closed.contains(var)) && child.getNumChildren() > 0)
			{
				sb.append("JoustMenu.menuItems[").append(var).append("].isOpen = true;\n");
			}
			sb.append(generateTree(tree, node, closed));
		}
	}
	return sb.toString();
}
%>
<%
final int experimentId = Values.getInt(request.getParameter("experiment_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final ItemContext tc = sc.getCurrentContext(Item.TRANSFORMATION);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("bioassay set", "bioassay sets");
final DbControl dc = sc.newDbControl();
Tree<BasicItem> analysisTree = null;
try
{
	final Experiment experiment = Experiment.getById(dc, experimentId);
	final boolean createPermission = experiment.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;
	final boolean writePermission = createPermission;

	final ItemQuery<BioAssaySet> query = Base.getConfiguredQuery(cc, true, experiment.getBioAssaySets(), mode);
	final ItemQuery<Transformation> transformationQuery = experiment.getTransformations();
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		analysisTree = getAnalysisTree(dc, query, transformationQuery);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	// Contains the ID:s of the bioassaysets that are closed in the tree
	Collection<String> closed = (Collection<String>)cc.getObject("closed");
	int numListed = 0;
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="table.js,tabcontrol.js,newjoust.js" styles="table.css,headertabcontrol.css,path.css,newjoust.css">
		<script language="JavaScript">
		function viewExperimentProperties()
		{
			location.href = '../index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>&cmd=ViewItem';
		}
		function viewOverview()
		{
			location.href = '../overview/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties')
			{
				viewExperimentProperties();
			}
			else if (tabId == 'overview')
			{
				viewOverview();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	
	<base:body >
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" />
		</p:path>

		<t:tabcontrol id="main" active="bioassaysets" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		
		<t:tab id="bioassaysets" title="Bioassay sets">
		
			<jsp:include page="analysis_tree.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="experiment_id" value="<%=experimentId%>" />
			</jsp:include>
		
		<base:buttongroup align="center">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		</t:tab>

		<t:tab id="overview" title="Overview" 
			tooltip="Get an overview of all hybridizations, biomaterials, etc. in this experiment" />

		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
