<%-- $Id: view_extravalue.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.ExtraValue"
	import="net.sf.basedb.core.ExtraValueType"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.NameablePluginAdaptor"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.EXTRAVALUE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();

final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final ExtraValue extraValue = ExtraValue.getById(dc, itemId);
	final BioAssaySet bioAssaySet = extraValue.getBioAssaySet();
	final Experiment experiment = bioAssaySet.getExperiment();
	final int experimentId = experiment.getId();
	RawDataType rawDataType = experiment.getRawDataType();
	
	ExtraValueType extraValueType = null;
	boolean readExtraValueType = true;
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		extraValueType = extraValue.getExtraValueType();
	}
	catch (PermissionDeniedException ex)
	{
		readExtraValueType = false;
	}
	try
	{
		job = extraValue.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}
	final boolean writePermission = extraValue.hasPermission(Permission.WRITE);
	final boolean deletePermission = extraValue.hasPermission(Permission.DELETE);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js,newjoust.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,newjoust.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			if (confirm('Extra values are deleted immediately and cannot be restored. Do you want to continue?'))
			{
				location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&experiment_id=<%=experimentId%>&item_id=<%=itemId%>');
			}
		}
		function copyJob(jobId)
		{
			var url = '../../../common/plugin/index.jsp?ID=<%=ID%>';
			url += '&cmd=CopyJob&job_id='+jobId;
			url += '&item_type=BIOASSAYSET&context_type=LIST'
			Main.openPopup(url, 'CopyJob', 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experimentId%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&cmd=ViewItem&experiement_id="+experimentId+"&item_id="+bioAssaySet.getId()%>" />
			<p:pathelement title="<%=HTML.encodeTags(extraValueType == null ? extraValue.getValueType().toString() : extraValueType.getName()) %>" />
		</p:path>
		
		<t:tabcontrol id="view" remember="false">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				tooltip="<%=deletePermission ? "Delete this extra value" : "You do not have permission to delete this extra value"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "copy.gif" : "copy_disabled.gif"%>" 
				onclick="<%=job == null ? "" : "copyJob('" + job.getId() + "')"%>" 
				title="Copy&hellip;"
				visible="<%=job != null && plugin != null && plugin.isInteractive() %>"
				tooltip="<%=writePermission ? "Copy this transformation" : "You do not have permission to copy this transformation"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="<%="runPlugin(" + itemId + ", 'ImportItem')"%>" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="<%="runPlugin(" + itemId + ", 'ExportItem')"%>" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="<%="runPlugin(" + itemId + ", 'RunPlugin')"%>"
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'extravalue.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
			
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(extraValue)%></i></div>
			
			<table width="100%">
			<tr valign="top">
			<td width="50%">
				<h4>Extra value</h4>
				<table class="form" cellspacing=0>
				<%
				if (extraValueType == null)
				{
					%>
					<tr>
						<td class="prompt">Type</td>
						<td><%=extraValue.getValueType()%></td>
					</tr>
					<%
				}
				else
				{
					%>
					<tr>
						<td class="prompt">Name</td>
						<td><%=Base.getLinkedName(ID, extraValueType, !readExtraValueType, writePermission)%></td>
					</tr>
					<%
				}
				%>
				<tr>
					<td class="prompt">Bioassay set</td>
					<td><%=Base.getLinkedName(ID, bioAssaySet, false, writePermission)%></td>
				</tr>
				<tr>
					<td class="prompt">Experiment</td>
					<td><%=Base.getLinkedName(ID, experiment, false, writePermission)%>
					(<%=experiment.getRawDataType()%>)</td>
				</tr>
				<tr>
					<td class="prompt">Values</td>
					<td>db: <%=extraValue.getNumValues()%>; file: <%=extraValue.getNumFileValues()%></td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(extraValueType != null ? extraValueType.getDescription() : "")%></td>
				</tr>
				</table>
				
				<h4>Job</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Job</td>
					<td><%=Base.getLinkedName(ID, job, !readJob, false)%></td>
				</tr>
				<tr valign=top>
					<td class="prompt">Started</td>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getStarted())%>
					</td>
				</tr>
				<tr valign=top>
					<td class="prompt">Ended</td>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%>
					</td>
				</tr>
				<tr valign=top>
					<td class="prompt">Server</td>
					<td>
						<%=job == null ? "" : HTML.encodeTags(job.getServer())%>
					</td>
				</tr>
				</table>
			</td>
			<td width="50%">
				<h4>Plugin &amp; parameters</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Plugin</td>
					<td><%=Base.getLinkedName(ID, plugin == null ? null : new NameablePluginAdaptor(plugin), 
							!readPlugin, plugin != null && plugin.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tr>
					<td class="prompt">Plugin configuration</td>
					<td><%=Base.getLinkedName(ID, configuration, !readConfiguration, 
						configuration != null && configuration.hasPermission(Permission.WRITE))%></td>
				</tr>
				<%
				if (job != null)
				{
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
						<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				</table>

			</td>
			</tr>
			</table>
			
			</div>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
