<%-- $Id: save_preset.jsp 4537 2008-09-18 09:23:28Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Ask for confirmation to delete a preset.


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
%>
<base:page type="popup" title="Save preset">
<base:head>
	<script language="JavaScript">
	// Initialise - set focus to name field
	function init()
	{
		var frm = document.forms["preset"];
		var presets = window.opener.document.forms['options'].presets;
		frm.name.value = presets[presets.selectedIndex].value;
		frm.name.focus();
	}

	// Validate the form
	function validateForm()
	{
		var frm = document.forms["preset"];
		if (Main.trimString(frm.name.value) == '')
		{
			frm.name.focus();
			alert("Please enter a name");
			return false;
		}
		var presets = window.opener.document.forms['options'].presets;
		for (var i = 0; i < presets.length; i++) // >
		{
			if (presets[i].text == frm.name.value) 
			{
				return confirm('Another preset with the same name already exists. Do want to replace it?');
			}
		}
		return true;
	}

	// Submit the form
	function savePreset()
	{
		var frm = document.forms["preset"];
		if (validateForm())
		{
			window.opener.saveAsPreset(frm.name.value);
			window.close();
		}
	}
	</script>
</base:head>
<base:body onload="init()">
	<p>
	<form name="preset" action="index.jsp" method="post" onsubmit="return validateForm();">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="cmd" value="Save">
	

	<h3 class="docked">Save preset <base:help helpid="experiment.overview.validationoptions.savepreset" /></h3>
	<div class="boxed" align="center">
		<br>
		<table class="form" cellspacing=0>
		<tr>
			<td class="prompt">Name</td>
			<td><input class="text required" type="text" name="name" value="" size="40" maxlength="40"></td>
		</tr>
		<tr>
			<td colspan="2">
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
			</td>
		</tr>
		</table>
		<p>
	</div>
	</form>

	<table align="center">
	<tr>
		<td width="50%"><base:button onclick="savePreset();" title="Ok" /></td>
		<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
	</tr>
	</table>

</base:body>
</base:page>
