<%-- $Id: edit_spotimages.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.SpotImages"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.RAWBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Create spot images";
	RawBioAssay rawBioAssay = RawBioAssay.getById(dc, itemId);
	SpotImages spi = rawBioAssay.getSpotImages();

	if (!rawBioAssay.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	boolean readRedImageFile = true;
	boolean readGreenImageFile = true;
	boolean readBlueImageFile = true;
	boolean readSpotImagesFile = true;
	File redImageFile = null;
	File greenImageFile = null;
	File blueImageFile = null;
	File spotImagesFile = null;
	try
	{
		redImageFile = spi.getRedImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readRedImageFile = false;
	}
	try
	{
		greenImageFile = spi.getGreenImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readGreenImageFile = false;
	}
	try
	{
		blueImageFile = spi.getBlueImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readBlueImageFile = false;
	}
	try
	{
		spotImagesFile = spi.getSpotImagesFile();
	}
	catch (PermissionDeniedException ex)
	{
		readSpotImagesFile = false;
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "RawBioAssay" tab
		function validateSpotImages()
		{
			var frm = document.forms['spotimages'];
			
			return true;
		}
		function selectRedFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setRedFileCallback';
			url += '&filter:INT:fileType=<%=SystemItems.getId(FileType.IMAGE)%>';
			if (frm.redfile_id.length > 1) url += '&item_id='+frm.redfile_id[1].value;
			Main.openPopup(url, 'SelectRedFile', 1000, 700);
		}
		function setRedFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.redfile_id.length < 2) // >
			{
				frm.redfile_id[frm.redfile_id.length] = new Option();
			}
			frm.redfile_id[1].value = fileId;
			frm.redfile_id[1].text = name;
			frm.redfile_id.selectedIndex = 1;
		}

		function selectGreenFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setGreenFileCallback';
			url += '&filter:INT:fileType=<%=SystemItems.getId(FileType.IMAGE)%>';
			if (frm.greenfile_id.length > 1) url += '&item_id='+frm.greenfile_id[1].value;
			Main.openPopup(url, 'SelectGreenFile', 1000, 700);
		}
		function setGreenFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.greenfile_id.length < 2) // >
			{
				frm.greenfile_id[frm.greenfile_id.length] = new Option();
			}
			frm.greenfile_id[1].value = fileId;
			frm.greenfile_id[1].text = name;
			frm.greenfile_id.selectedIndex = 1;
		}
		
		function selectBlueFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setBlueFileCallback';
			url += '&filter:INT:fileType=<%=SystemItems.getId(FileType.IMAGE)%>';
			if (frm.bluefile_id.length > 1) url += '&item_id='+frm.bluefile_id[1].value;
			Main.openPopup(url, 'SelectBlueFile', 1000, 700);
		}
		function setBlueFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.bluefile_id.length < 2) // >
			{
				frm.bluefile_id[frm.bluefile_id.length] = new Option();
			}
			frm.bluefile_id[1].value = fileId;
			frm.bluefile_id[1].text = name;
			frm.bluefile_id.selectedIndex = 1;
		}

		function browseOnClick()
		{
			Main.openPopup('../../filemanager/index.jsp?ID=<%=ID%>&cmd=SaveAs&callback=setSaveAsCallback', 'SaveAs', 1000, 700);
		}
		function setSaveAsCallback(path)
		{
			var frm = document.forms['spotimages'];
			frm.path.value = path;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['spotimages'];
			frm.submit();
		}

		</script>
	</base:head>
	<base:body>
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="spotimages" onsubmit="return false;">
		<input type="hidden" name="item_id" value="<%=itemId%>">
		<input type="hidden" name="cmd" value="CreateSpotImages">

		<h3 class="docked"><%=title%> <base:help helpid="rawbioassay.edit.spotimages" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*300)+"px;"%>" 
			position="bottom">
		<t:tab id="info" title="Spot image parameters" validate="validateSpotImages()">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">X scale</td>
				<td><input type="text" <%=requiredClazz%> name="x_scale"
					value="<%=spi.getXScale()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<td class="prompt">Y scale</td>
				<td><input type="text" <%=requiredClazz%> name="y_scale"
					value="<%=spi.getYScale()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">X offset</td>
				<td><input type="text" <%=requiredClazz%> name="x_offset" 
					value="<%=spi.getXOffset()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<td class="prompt">Y offset</td>
				<td><input type="text" <%=requiredClazz%> name="y_offset" 
					value="<%=spi.getYOffset()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Spot size</td>
				<td><input type="text" <%=requiredClazz%> name="spotsize"
					value="<%=spi.getSpotsize()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<td class="prompt">Gamma correction</td>
				<td><input type="text" <%=requiredClazz%> name="gamma"
					value="<%=spi.getGamma()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.numberOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Quality</td>
				<td><input type="text" <%=requiredClazz%> name="quality" 
					value="<%=spi.getQuality()%>" size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>

			<tr>
				<td class="prompt">Red image file</td>
				<td colspan="3">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<select name="redfile_id" size="1" 
							style="width: 20em;">
							<option value="0">- none -
							<%
							if (redImageFile != null)
							{
								%>
								<option value="<%=redImageFile.getId()%>" selected><%=HTML.encodeTags(redImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
						&nbsp;
					</td>
					<td><base:button onclick="selectRedFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<td class="prompt">Green image file</td>
				<td colspan="3">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<select name="greenfile_id" size="1" 
							style="width: 20em;">
							<option value="0">- none -
							<%
							if (greenImageFile != null)
							{
								%>
								<option value="<%=greenImageFile.getId()%>" selected><%=HTML.encodeTags(greenImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
						&nbsp;
					</td>
					<td><base:button onclick="selectGreenFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<td class="prompt">Blue image file</td>
				<td colspan="3">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<select name="bluefile_id" size="1" 
							style="width: 20em;">
							<option value="0">- none -
							<%
							if (blueImageFile != null)
							{
								%>
								<option value="<%=blueImageFile.getId()%>" selected><%=HTML.encodeTags(blueImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
						&nbsp;
					</td>
					<td><base:button onclick="selectBlueFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>
			
			<tr valign="top">
				<td class="prompt">Save as</td>
				<td colspan="3">
					<table>
					<tr>
					<td><input type="text" class="text required" 
						name="path" size="40" 
						value="<%=spotImagesFile == null ? "" : HTML.encodeTags(spotImagesFile.getPath().toString())%>"></td>
					<td><base:button 
							title="Browse..."
							onclick="browseOnClick()"
							/>
					</td>
					</tr>
					</table>
					<input type="checkbox" name="overwrite" value="1">Overwrite existing file
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Create" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
